Transactions
Data model
Account Interest Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
Bond Coupon Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
grossAmountnumberRequiredTotal coupon amount. Denominated in instrument currency.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository the instrument is held in.
Bond Redemption Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units redeemed.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository affected by the transaction.
Bond Trade Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
accruedInterestnumberRequiredInterest accumulated on the bond from the latest repayment date to the transaction date. Denominated in instrument currency.
commissionnumberRequiredCommission charged by the bank or custodian. Denominated in account currency. A positive number means commission paid.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units bought or sold.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository affected by the transaction.
Cash Transfer Transaction
The cash transfer transaction type can be used for both external cash transfers to an outside account and internal cash transfers between accounts. This is done by assigning the counterparty-transaction relationships object with the ID of the related counterparty transaction. See example.
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
counterparty-transactionCounterparty transaction is the linked transaction associated with the transaction being displayed.
Dividend Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
commissionnumberCommission charged by the bank or custodian. Denominated in account currency. A positive number means commission paid. Defaults to zero if not specified.
grossAmountnumberRequiredTotal dividend amount before any deductions. Denominated in instrument currency.
taxnumberRequiredTax charged as part of the transaction. Denominated in instrument currency.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository the instrument is held in.
Equity Trade Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commissionnumberRequiredCommission charged by the bank or custodian. Denominated in account currency. A positive number means commission paid.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units bought or sold.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository affected by the transaction.
Fee Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
categorystringType of fee. Possible values: "custody", "management", "other". Default is "other".
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
Futures Trade Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commissionnumberRequiredCommission charged by the bank or custodian. Denominated in account currency. A positive number means commission paid.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units bought or sold.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository affected by the transaction.
Futures Execution Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commissionnumberRequiredCommission charged by the bank or custodian. Denominated in account currency. A positive number means commission paid.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units bought or sold.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
openingTransactionOpening transaction is the futures trade transaction associated with the transaction being displayed.
depositoryDepository represents the depository affected by the transaction.
FX Forward Cash Settlement Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
fxForwardThe FX Forward agreement that is being settled.
FX Forward Physical Delivery Transaction
primaryAccountAmountnumberRequiredAmount deposited or withdrawn from the related account
primaryAccount. Denominated in the currency of the primary account.secondaryAccountAmountnumberRequiredAmount deposited or withdrawn from the related account
secondaryAccount. Denominated in the currency of the secondary account.tradeDatestringRequiredISO 8601 representation of the transaction's trade date.
valueDatestringRequiredISO 8601 representation of the transaction's value date.
Relationships
primaryAccountRepresents the bank account affected by the primary currency of the FX pair.
secondaryAccountRepresents the bank account affected by the secondary currency of the FX pair.
fxForwardThe FX Forward agreement that is being settled.
FX Spot Transaction
commentstringA brief text note or explanation related to the transaction.
inflowAccountAmountnumberRequiredAmount deposited to the related account
inflowAccount. The amount must be positive and is denominated in the currency of the inflow account.outflowAccountAmountnumberRequiredAmount withdrawn from the related account
outflowAccount. The amount must be negative and is denominated in the currency of the outflow account.tradeDatestringRequiredISO 8601 representation of the transaction's trade date.
valueDatestringRequiredISO 8601 representation of the transaction's value date.
Relationships
inflowAccountAccount to which the inflow currency of the FX pair is deposited.
outflowAccountAccount from which the outflow currency of the FX pair is withdrawn.
Index-Linked Bond Coupon Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
grossAmountnumberRequiredTotal coupon amount. Denominated in instrument currency.
indexFactornumberRequiredThe index factor to use for the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository the instrument is held in.
Index-Linked Bond Redemption Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
indexFactornumberRequiredThe index factor to use for the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units redeemed.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository affected by the transaction.
Index-Linked Bond Trade Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
accruedInterestnumberRequiredInterest accumulated on the bond from the latest repayment date to the transaction date. Denominated in instrument currency.
commissionnumberRequiredCommission charged by the bank or custodian. Denominated in account currency. A positive number means commission paid.
commentstringA brief text note or explanation related to the transaction.
indexFactornumberThe index factor to use for the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units bought or sold.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository affected by the transaction.
Loan Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
interestnumberInterest amount related to the loan. Denominated in account currency.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date.
valueDatestringRequiredISO 8601 representation of the transaction's value date.
Relationships
accountAccount represents the bank account affected by the transaction.
loanThe loan instrument that the transaction belongs to.
Other Transaction
A transaction whose kind has none of the types above (for example a correction) is returned with type other-transaction.
accountAmountnumberAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
nullwhen not set.tradeDatestringThe transaction's trade date (
yyyy-MM-dd).valueDatestringThe transaction's value date (
yyyy-MM-dd).assetstringID of the instrument the transaction relates to, or
null.
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction, when there is one.
depositoryDepository represents the depository affected by the transaction, when there is one.
Private Market Fund Distribution Transaction
categorystringRequiredType of distribution transaction. Possible values:
"distribution","capital-gain","dividend","return-of-capital","carried-interest","withholding-tax","redemption","management-fee-rebate","other-fee-rebate","reallocation-premium","rebalancing-adjustment","reimbursement".amountnumberRequiredThe distributed amount from the fund. Denominated in the fund's currency. The distributed amount should be a negative value, with
accountAmountpositive (a positive value reverses a distribution).recallableAmountnumberRequiredThe part of the amount that is recallable. Use
0for a non-recallable distribution. Use theamountvalue for a fully recallable distribution. Or use a number between0andamountfor a partially recallable distribution.affectsEstimatedNavboolRequiredWhether this transaction should impact the instrument’s estimated NAV at the transaction date. Set to
trueto include orfalseto exclude.affectsMultiplesboolRequiredWhether this cash flow is included in private‑markets multiples calculations (e.g., TVPI, DPI, RVPI). Set to
trueto include orfalseto exclude. Recommended value istruefor most transactions.affectsIrrboolRequiredWhether this cash flow is included in IRR calculations. Set to
trueto include orfalseto exclude. Recommended value istruefor most transactions.affectsCostBaseboolRequiredWhether this transaction adjusts the investor’s cost basis. Set to
trueto adjust cost basis (e.g., capital calls or certain fees) orfalseif it should not affect cost basis. Recommended value istruefor most transactions.accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the fund affected by the transaction.
Private Market Fund Drawdown Transaction
categorystringRequiredType of drawdown transaction. Possible values:
"capital-call","management-fee","interest-received","other-fee".amountnumberRequiredThe called amount from the fund. Denominated in the fund's currency. The drawdown amount should have postive sign (negative values are allowed for corrections).
effectOnUnfundedCommitmentnumberRequiredSigned change to the remaining unfunded commitment caused by this drawdown. Use a negative value to reduce the unfunded commitment (typical for capital calls), a positive value to increase it (e.g., corrections), or "0" for no change.
affectsEstimatedNavboolRequiredWhether this transaction should impact the instrument’s estimated NAV at the transaction date. Set to
trueto include orfalseto exclude. Recommended value istruefor most transactions.affectsMultiplesboolRequiredWhether this cash flow is included in private‑markets multiples calculations (e.g., TVPI, DPI, RVPI). Set to
trueto include orfalseto exclude. Recommended value istruefor most transactions.affectsIrrboolRequiredWhether this cash flow is included in IRR calculations. Set to
trueto include orfalseto exclude. Recommended value istruefor most transactions.affectsCostBaseboolRequiredWhether this transaction adjusts the investor’s cost basis. Set to
trueto adjust cost basis (e.g., capital calls or certain fees) orfalseif it should not affect cost basis. Recommended value istruefor most transactions.accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the fund affected by the transaction.
Refund Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
Zero Coupon Bond Trade Transaction
accountAmountnumberRequiredAmount deposited or withdrawn from the account. Denominated in account currency.
commissionnumberRequiredCommission charged by the bank or custodian. Denominated in account currency. A positive number means commission paid.
commentstringA brief text note or explanation related to the transaction.
tradeDatestringRequiredISO 8601 representation of the transaction's trade date (end-of-day).
unitPricenumberRequiredPrice per instrument unit.
unitsnumberRequiredNumber of units bought or sold.
valueDatestringRequiredISO 8601 representation of the transaction's value date (end-of-day).
Relationships
accountAccount represents the bank account affected by the transaction.
instrumentInstrument represents the instrument affected by the transaction.
depositoryDepository represents the depository affected by the transaction.
List transactions
Fetch all transactions within a specified period. At least one of accountId, depositoryId, or instrumentId must be specified.
Query parameters
accountIdqueryAccount identifier. Can be repeated to include several accounts.
depositoryIdqueryDepository identifier. Can be repeated to include several depositories.
instrumentIdqueryInstrument identifier (24 hexadecimal characters). Filters transactions to those involving the given instrument. An unknown instrument answers
404.fromDatequeryRequiredFirst day in the time period (
yyyy-MM-dd).toDatequeryRequiredLast day in the time period (
yyyy-MM-dd).
curl -G https://api.aleta.ai/api/v3/transactions \
-H "Accept: application/vnd.api+json" \
-H "Authorization: Bearer {access_token}" \
-d accountId=6698ffbdda04cf5d2d55a265 \
-d fromDate=2024-07-01 \
-d toDate=2024-07-01
{
"data": [
{
"id": "66990014c5dc848e8f97c1bb",
"type": "account-interest-transaction",
"attributes": {
"accountAmount": 1594.87,
"comment": "Account Interest Q2",
"tradeDate": "2024-07-01",
"valueDate": "2024-07-01"
},
"relationships": {
"account": {
"data": {
"type": "account",
"id": "6698ffbdda04cf5d2d55a265"
}
}
}
}
]
}
Create a transaction
Create a new transaction for an account. The created transaction is returned with status 201.
The accepted type values are account-interest-transaction, bond-coupon-transaction, bond-redemption-transaction, bond-trade-transaction, cash-transfer-transaction, dividend-transaction, equity-trade-transaction, fee-transaction, fx-spot-transaction, index-linked-bond-coupon-transaction, index-linked-bond-redemption-transaction, index-linked-bond-trade-transaction, private-market-fund-distribution-transaction, private-market-fund-drawdown-transaction, refund-transaction and zero-coupon-bond-trade-transaction. Other types are not accepted.
tradeDate and valueDate must use the format yyyy-MM-dd, and amounts must be JSON numbers; otherwise the request answers 400 with Cannot parse request body.
Internal cash transfer
For an internal cash transfer, you will need to create each leg of the transaction separately.
- For the first leg, create a transaction in the same way as an external cash transfer (the External Cash Transfer example).
- For the second leg, include the
counterparty-transactionobject in the relationships section and set it to the ID of the transaction created as the first leg.
When you send the POST request for the second leg, the transaction referenced in the counterparty-transaction will be automatically updated, and a counterparty-transaction object will also be added to that initial transaction.
The second leg must have the same tradeDate and valueDate and the same account currency as the first leg, and the two accountAmount values must offset each other to within 0.005. Otherwise the request answers 400.
Private market fund transactions
For private-market-fund-drawdown-transaction and private-market-fund-distribution-transaction, the instrument must be a private market fund. accountAmount must equal amount with the opposite sign: no exchange rate is applied between the two. The fund must belong to the account's portfolio, and tradeDate must not be before the fund's entry date. Otherwise the request answers 400 with the reason, for example Contract with ID '{id}' not found. when the instrument is not a private market fund.
curl -X POST https://api.aleta.ai/api/v3/transactions \
-H "Accept: application/vnd.api+json" \
-H "Authorization: Bearer {access_token}" \
-H "Content-Type: application/vnd.api+json" \
-d '{
"data": {
"type": "bond-coupon-transaction",
"attributes": {
"accountAmount": 7500.00,
"comment": "Bond Coupon",
"grossAmount": 7500.00,
"tradeDate": "2024-07-01",
"valueDate": "2024-07-01"
},
"relationships": {
"account": {
"data": {
"type": "account",
"id": "6698ffbdda04cf5d2d55a265"
}
},
"instrument": {
"data": {
"type": "instrument",
"id": "b5afc699f5e3a15556d2a00c"
}
},
"depository": {
"data": {
"type": "depository",
"id": "6698ffae47a5a2c8b2554ee8"
}
}
}
}
}'
{
"data": {
"id": "66990014c5dc848e8f97c1bb",
"type": "bond-coupon-transaction",
"attributes": {
"accountAmount": 7500.00,
"comment": "Bond Coupon",
"grossAmount": 7500.00,
"tradeDate": "2024-07-01",
"valueDate": "2024-07-01"
},
"relationships": {
"account": {
"data": {
"type": "account",
"id": "6698ffbdda04cf5d2d55a265"
}
},
"instrument": {
"data": {
"type": "instrument",
"id": "b5afc699f5e3a15556d2a00c"
}
},
"depository": {
"data": {
"type": "depository",
"id": "6698ffae47a5a2c8b2554ee8"
}
}
}
}
}